#ifndef fltpt_H
#define fltpt_H

typedef unsigned char bcd32[32];

extern bcd32 k0;
extern bcd32 kp1;
extern bcd32 kp2;
extern bcd32 km1;
extern bcd32 kphalf;
extern bcd32 kpi;
extern bcd32 k2pi;
extern bcd32 kpio2;
extern bcd32 kpio4;
extern bcd32 k2opi;
extern bcd32 ksqrtpi;
extern bcd32 kdtor;
extern bcd32 krtod;
extern bcd32 kln2;
extern bcd32 kln10;
extern bcd32 klnmax;
extern bcd32 ksqrt2;
extern bcd32 expser;
extern bcd32 kpmax;
extern bcd32 kmaxgam;
extern bcd32 keuler;

#ifdef __cplusplus
extern "C" {
#endif
void bcdadd(bcd32 a,bcd32 b,bcd32 c);
void bcdsub(bcd32 a,bcd32 b,bcd32 c);
void bcdmul(bcd32 a,bcd32 b,bcd32 c);
void bcddiv(bcd32 a,bcd32 b,bcd32 c);
void bcdsqrt(bcd32 a,bcd32 c);
void bcdsin(bcd32 a,bcd32 c);
void bcdsin2(bcd32 a,bcd32 c);
void bcdcos(bcd32 a,bcd32 c);
void bcdtan(bcd32 a,bcd32 c);
void bcdcsc(bcd32 a,bcd32 c);
void bcdsec(bcd32 a,bcd32 c);
void bcdcot(bcd32 a,bcd32 c);
void bcdasin(bcd32 a,bcd32 c);
void bcdacos(bcd32 a,bcd32 c);
void bcdatan(bcd32 a,bcd32 c);
void bcdatan2(bcd32 a,bcd32 b,bcd32 c);
void bcdacot(bcd32 a,bcd32 c);
void bcdacsc(bcd32 a,bcd32 c);
void bcdasec(bcd32 a,bcd32 c);
void bcdsinh(bcd32 a,bcd32 c);
void bcdcosh(bcd32 a,bcd32 c);
void bcdtanh(bcd32 a,bcd32 c);
void bcdcsch(bcd32 a,bcd32 c);
void bcdsech(bcd32 a,bcd32 c);
void bcdcoth(bcd32 a,bcd32 c);
void bcdasinh(bcd32 a,bcd32 c);
void bcdacosh(bcd32 a,bcd32 c);
void bcdatanh(bcd32 a,bcd32 c);
void bcdacsch(bcd32 a,bcd32 c);
void bcdasech(bcd32 a,bcd32 c);
void bcdacoth(bcd32 a,bcd32 c);
void bcdint(bcd32 a,bcd32 c);
void bcdfrac(bcd32 a,bcd32 c);
void bcdneg(bcd32 a,bcd32 c);
void bcdabs(bcd32 a,bcd32 c);
void bcdchs(bcd32 a,bcd32 c);
void bcdround(bcd32 a,bcd32 c,int pos);
void bcdmov(bcd32 a,bcd32 c);
int  bcdcmp(bcd32 a,bcd32 b);
void bcdclear(bcd32 a);
void bcdlog(bcd32 a,bcd32 c);
void bcdlog10(bcd32 a,bcd32 c);
void bcdexp(bcd32 a,bcd32 c);
void bcdten2x(bcd32 a,bcd32 c);
void bcde2f(bcd32 a,bcd32 c);
void bcdhypot(bcd32 a,bcd32 b,bcd32 c);
void bcdpoly(bcd32 clist,bcd32 x,bcd32 y,int n);
void bcdpow(bcd32 y,bcd32 x,bcd32 z);
void bcdgammax(bcd32 a,bcd32 c);
void bcdlgamma(bcd32 a,bcd32 c);
void bcdmax(bcd32 a,bcd32 b,bcd32 c);
void bcdmin(bcd32 a,bcd32 b,bcd32 c);

#ifdef __cplusplus
}
#endif
#endif
